#! /bin/sh

function pango() {
	$PREFIX/bin/pango-querymodules.exe > modules-root.lst || return $?

	grep 'ModulesPath = ' modules-root.lst | sed 's/.*ModulesPath = \(.*\)/\1/' | sed 's/\\/\\\\\\\\/g' | head -c -2 > path.txt
	sed "s/^\"`cat path.txt`/\"..\\\\\\\\lib\\\\\\\\pango\\\\\\\\1.6.0\\\\\\\\modules/" modules-root.lst > $PREFIX/etc/pango/pango.modules

	CLEAN+="modules-root.lst path.txt "
	ADD+="pango.zip: $PREFIX/etc/pango/pango.modules\n"
}

function pixbuf() {
	$PREFIX/bin/gdk-pixbuf-query-loaders.exe > pixbuf-modules-root.lst || return $?

	grep 'LoaderDir = ' pixbuf-modules-root.lst | sed 's/.*LoaderDir = \(.*\)/\1/' | sed 's/\\/\//g' | head -c -2 > pixbuf-path.txt
	sed "s,^\"`cat pixbuf-path.txt`,\"../lib/gdk-pixbuf-2.0/2.10.0/loaders," pixbuf-modules-root.lst > $PREFIX/lib/gdk-pixbuf-2.0/2.10.0/loaders/loaders.cache

	CLEAN+="pixbuf-modules-root.lst pixbuf-path.txt "
	ADD+="gdk-pixbuf.zip: $PREFIX/lib/gdk-pixbuf-2.0/2.10.0/loaders/loaders.cache\n"
}

function gtk() {
	$PREFIX/bin/gtk-query-immodules-3.0.exe | sed -e "s,^\".:$PREFIX,..," > $PREFIX/lib/gtk-3.0/3.0.0/immodules.cache || return $?

	ADD+="gtk+.zip: $PREFIX/lib/gtk-3.0/3.0.0/immodules.cache\n"
}

if test -z "$PREFIX" -o -z "$SYS"; then
	echo "\$PREFIX and \$SYS required"
	exit 1
fi

if test "x$SYS" = "xmingw32" -o "x$SYS" = "xmingw64"; then
	if ! test -e /proc/sys/fs/binfmt_misc/windows; then
		echo "Windows handler required"
		exit 2
	fi
	if test -f build/.pango-staged-$SYS; then
		pango || (echo "Pango package post action failed!"; exit 1) || exit 1
	fi
	if test -f build/.gdk-pixbuf-staged-$SYS; then
		pixbuf || (echo "gdk-pixbuf package post action failed!"; exit 1) || exit 1
	fi
	if test -f build/.gtk-staged-$SYS; then
		gtk || (echo "gtk package post action failed!"; exit 1) || exit 1
	fi
fi

if test -n "$CLEAN"; then
	echo "Run:"
	echo "rm -vf $CLEAN"
	echo
fi
if test -n "$ADD"; then
	echo "Add:"
	echo -en "$ADD"
fi
